
class Mask88 :public _BaseLearning
{
#define iMaxMethods 2
public:
    class PatternChars {
    public:
        PatternChars()
        {
            value7 = 0;
            value8 = 0;
            theChar = 0;
            next = 0;
        }
        
        ~PatternChars()
        {
            PatternChars *current = next;
            while (current) {
                PatternChars *next1 = current->next;
                current->next = 0;
                delete current;
                current = next1;
            }
        }
        
        void PInsert1Char(char theChar0,uint64_t value7,uint64_t value8,float whRatio,float ratio_w)
        {
            PatternChars *new1 = new PatternChars();
            new1->value7 = value7;
            new1->value8 = value8;
            new1->theChar = theChar0;
            new1->ratio_w = ratio_w;
            new1->widthHeightRatio = whRatio;
            new1->next = this->next;
            this->next = new1;
        }
        
        float CountBits(int64_t value)
        {
            int count = 0;
            for (int i=0;i<64;i++) {
                if (value < 0) {
                    count++;
                }
                value <<= 1;
            }
            return count;
        }
        
        void PFind1Char(CharMaps &result_maps,uint64_t value7,uint64_t value8 ,float whRatio)
        {
            PatternChars *currentChar = next;
            
            while (currentChar) {
                //if (currentChar->theChar == '6') {
                    //("");
                //}
                uint64_t maskXOR7 = (currentChar->value7 ^ value7);
                
                float matchs7 = 49 - CountBits(maskXOR7);
                
                float ratio7 = matchs7 / 49;
                
                uint64_t maskXOR8 = (currentChar->value8 ^ value8);
                
                float matchs8 = 64 - CountBits(maskXOR8);
                
                float ratio8 = matchs8 / 64;
                float ratio = (ratio7 + ratio8) / 2;
                
                if (WidthHeightRatioDelta(this->widthHeightRatio , currentChar->widthHeightRatio,ratio_w)) {
                    ratio = 0;
                }
                if (ratio > 0) {
                    result_maps.blocks->chars[currentChar->theChar].SetMax(ratio);
                }
                
                currentChar = currentChar->next;
            }
        }
        
        uint64_t value7;
        uint64_t value8;
        float widthHeightRatio;
        float ratio_w;
        char theChar;
        
        PatternChars *next;
    };
    
    
    Mask88()
    {
        strcpy(names,"Mask88");
        count = 0;
    }
    
    ~Mask88()
    {
        
    }
    char mGetPatterns(MyBitMap &bits,int useBits,uint64_t *result0)
    {
        FloatRect clip;
        double ratiox = (double)bits.width / (useBits);
        double ratioy = (double)bits.height / (useBits);
        double xx = 0;//ratiox;
        double yy = 0;//ratioy;
        clip.origin.x = xx;
        clip.origin.y = yy;
        clip.size.width = ratiox ;
        clip.size.height = ratioy ;
        uint64_t result = 0;
        for (int y=0;y<useBits;y++) {
            xx = 0;//ratiox;
            clip.origin.x = xx;
            for (int x=0;x<useBits;x++) {
                double ratio = GetPixelRatio(bits,clip);
                result <<= 1;
                if (ratio >= 0.5) { //0.35
                    result |= 1;
                }
                xx += ratiox;
                clip.origin.x = xx;
            }
            yy += ratioy;
            clip.origin.y = yy;
        }
        *result0 = result;
        return 1;
    }
    virtual char Process1Char(char theChar,CharMaps *result_maps,MyBitMap &bits, FloatRect clip,float ratio_w)
    {
        uint64_t mask8 ;
        if (mGetPatterns(bits,8,&mask8)) {
            uint64_t mask7 ;
            if (mGetPatterns(bits,7,&mask7)) {
                float wideHeightRatio0 = (float)bits.width / bits.height;
                if (theChar > 0) {
                    count++;
                    
                    charsRoot.PInsert1Char(theChar, mask7,mask8,wideHeightRatio0,ratio_w);
                    
                } else {
                    
                    charsRoot.PFind1Char(*result_maps, mask7,mask8,wideHeightRatio0);
                    
                }
            }
        }
        return 1;
    }
    
    PatternChars charsRoot;
    int count;
    
};
