//
//  MyPlugin.h
//  Runner
//
//  Created by ansun on 2021/3/3. //yyyy/mm/dd
//

#ifndef MyPlugin_h
#define MyPlugin_h
#import <Flutter/Flutter.h>
#import <AVFoundation/AVFoundation.h>


@interface MyPlugin : NSObject
<AVCaptureVideoDataOutputSampleBufferDelegate>
NS_ASSUME_NONNULL_BEGIN
//-(void)setUpFirst;
-(void)setPhotoFeedBack:(int)value;
-(void)captureOutput:(AVCaptureOutput *)captureOutput didOutputSampleBuffer:(CMSampleBufferRef)sampleBuffer fromConnection:(AVCaptureConnection *)connection;
-(void)setup:(double)focus expose:(double)expose zoom:(double)zoom iso:(double)iso;
-(double)pow:(double)value1 with:(double)value2;
-(void)SuspendThread;
-(void)setFlutterPaths:(NSDictionary*)path;
-(void)deactivateOCR;
-(void)activateOCR;
//@property double use_GrayDeltaThreshold;
@property char suspendForUI_Slider;
NS_ASSUME_NONNULL_END
@end

#endif /* MyPlugin_h */
