#ifndef FONTSWINDOW_H
#define FONTSWINDOW_H

#include <QMainWindow>
#include <QObject>
#include <QWidget>
#include "QWindow"
#include "FontParse.h"

class FontsWindow :   public QWidget
{

Q_OBJECT

public:

    explicit FontsWindow(QWidget *parent = nullptr);
    void FindFonts();
    void ShowCharPixel(LearnPackageRef learnPackage, QFont font,QChar theChar,int index);
    void ShowTextPixel(LearnPackageRef learnPackage);
    void SetupShowEffect();
    void CollectFonts();
    void LearnCharsByAllFonts();

    LearnPackageRef font_learnedPattern = nullptr;

private slots:
    void ButtonLearnClicked();
    void stateChanged(int state);
private:

    void resizeEvent(QResizeEvent *event) override;

};

#endif // FONTSWINDOW_H
