#include "mainwindow.h"
#include "fontswindow.h"
#include "QScreen"
#include <QApplication>

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    QSize size = qApp->screens()[0]->size();
    int width = size.width() /2 - 40;

    FontsWindow fonts;
    fonts.resize(width,size.height()-80);
    fonts.move(width+40,0);
    fonts.show();


    MainWindow w(&fonts);
    w.show();


    w.resize(width,size.height()-80);
    w.move(20,0);

    return a.exec();
}
