import UIKit
import Flutter


var app : AppDelegate?

@UIApplicationMain
@objc class AppDelegate  : FlutterAppDelegate {
    @objc  public var cameraViewChannel: FlutterMethodChannel?
    @objc public var task_channel: FlutterMethodChannel? //: "my_task_channel", binaryMessenger: registrar.messenger())
    @objc public var myPreviewImage:UIImageView? ;
    @objc public var cameraPreview:UIView?;
    @objc public var memoryWarning : Int = 0;

    @objc public static func GetAPP() -> AppDelegate {
        return app!
        
    }
    override func applicationDidReceiveMemoryWarning(_ application: UIApplication) {
        #if DEBUG
            print("applicationDidReceiveMemoryWarning\n");
        #endif
        memoryWarning += 1;
    }
    override func application( _ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
    ) -> Bool
    {
        app = self;
        
        let registerValue = self.registrar(forPlugin: "iOSCameraPlugin");
        GeneratedPluginRegistrant.register(with: self)
        
        SwiftiOSCameraPlugin.register(with: registerValue!)
        task_channel = FlutterMethodChannel(name: "my_task_channel", binaryMessenger: registerValue!.messenger())
        return super.application(application, didFinishLaunchingWithOptions: launchOptions)
    }
    
    
}


